#pragma once

#include <windows.h>
#include <tchar.h>
#include "viewer plugins.h"
#include <vorbis/vorbisfile.h>
#include <FLAC/metadata.h>
#include "easyflac.h"

namespace NUtils
{
	enum FileType
	{
		TYPE_UNKNOWN,
		TYPE_FLAC,
		TYPE_OGGFLAC,
		TYPE_OGGVORBIS
	};

	FileType GetTypeFromBuffer(BYTE *pBuffer, UINT uiBufferSize);
	int StringCopy(TCHAR *dest, const TCHAR *source, int destSizeChars);
	int StringCopyConvert(TCHAR *dest, const char *source, int destSizeChars);
	char *StringExtract(BYTE *source, DWORD dwSourceSizeBytes);
	int StringExtractConvert(TCHAR *dest, BYTE *source, int destSizeChars, DWORD dwSourceSizeBytes);
	bool CopyVersionNumber(DWORD *pdwHigh, DWORD *pdwLow, TCHAR *szItemName, BYTE *pLang, const LPVOID pVerData);
	bool CopyVersionString(TCHAR *szDestBuffer, UINT uiDestBufferSize, TCHAR *szItemName, BYTE *pLang, const LPVOID pVerData);
};
