#pragma once

class CWin32StreamWrapper : public CWin32Wrapper
{
protected:
	IStream *m_pStream;
	bool m_bSeekable;

public:
	CWin32StreamWrapper(NUtils::FileType fileType, IStream *pStream, bool bSeekable);
	virtual ~CWin32StreamWrapper();

	virtual FLAC__StreamDecoderReadStatus v_easyflac_read_func(const EasyFLAC__StreamDecoder *decoder, FLAC__byte buffer[], unsigned *bytes);

	virtual size_t v_vorbisfile_read_func(void *ptr, size_t size, size_t nmemb);
	virtual int    v_vorbisfile_seek_func(ogg_int64_t offset, int whence);
	virtual long   v_vorbisfile_tell_func();
};
